#include <GL/glut.h>
#include <stdio.h>
#include <stdlib.h>
#include <math.h>
//schreiben lassen
#include <GL/glext.h>

#ifndef	M_PI				// for Windows
#define M_PI 3.14159265358979323846
#endif
#ifndef SGN					// Signum
#define SGN(y) (((y) < 0) ? -1 : ((y) > 0))
#endif
#ifndef MIN
#define MIN(a,b) ((a) > (b))? (b) : (a)
#endif
#ifndef MAX
#define MAX(a,b) ((a) > (b))? (a) : (b)
#endif

//////////////////////////////////////////////////////////////
//	Fenster Initialisierung
//////////////////////////////////////////////////////////////
//! Die Startposition des Fensters
#define WIN_POS_X	0
#define WIN_POS_Y	0

//! Breite des Fensters
#define WIN_WIDTH	1024
//! Hoehe des Fensters
#define WIN_HEIGHT	768


// Uncomment, wenn man Stencil Buffer braucht
//#define NEED_STENCIL

// Uncomment, wenn man Accumulation Buffer braucht
//#define NEED_ACCUM


//////////////////////////////////////////////////////////////
//	OpenGL Darstellungsmodus
//////////////////////////////////////////////////////////////
//! Default OpenGL Modus:  RGBA mit double Buffering und
//! depth buffer (Z-Buffer)
//! Verwendung der Stencil und Accumulation Buffers
#if defined NEED_STENCIL && defined NEED_ACCUM
#define USED_MODUS	GLUT_RGBA |  GLUT_DEPTH | GLUT_DOUBLE | GLUT_STENCIL | GLUT_ACCUM
#elif defined NEED_STENCIL
#define USED_MODUS	GLUT_RGBA |  GLUT_DEPTH | GLUT_DOUBLE | GLUT_STENCIL
#elif defined NEED_ACCUM
#define USED_MODUS	GLUT_RGBA |  GLUT_DEPTH | GLUT_DOUBLE | GLUT_ACCUM
#else
#define USED_MODUS	GLUT_RGBA |  GLUT_DEPTH | GLUT_DOUBLE
#endif




/////////////////////////////////////////////////////////////
//	Menuelemente
/////////////////////////////////////////////////////////////
#define MENU_OPEN			"Open"
#define MENU_SHADE			"Shading"
#define MENU_EXIT			"Exit"

enum MENU_IDs {
	ID_MENU_OPEN = 1,
	ID_MENU_SHADE,
	ID_MENU_EXIT
};


//////////////////////////////////////////////////////////////
//	Programanhaengige Konstanten und Variablen
/////////////////////////////////////////////////////////////
#define PROG_NAME	"Simple Multitexturing"

int MainWin;		// Identifier vom Hauptfenster
int MainMenu;		// Identifier vom Hauptmenu

//! Struktur fuer Bearbeitung der Mausevents
struct MouseStruct {
	int LastState;
	int OldX;
	int OldY;
	int ScreenX;
	int ScreenY;
	int MoveX;
	int MoveY;
	double Radius;
} globMouse;


//Texturausdehnung
int twidth=256;
int theight=256;
GLuint mapnames[9];

/////////////////////////////////////////////////////////////
//	Funktionen und Prozeduren
/////////////////////////////////////////////////////////////
void MenuFuncFile (int);
void DisplayFunc ();
void ReshapeFunc (int,int);
void MouseFunc (int,int,int,int);
void MouseMove (int,int);
void KeyboardFunc (unsigned char,int,int);
void SpecialKeyboardFunc (int,int,int);
void IdleFunc ();
GLubyte* read_Texture(char* pfad,int width, int height);
void specTexture(char* pfad,GLuint mapname);
void draw_environment_cube();
void draw_ground();
//
//	Anfang des OpenGL Programmes
//
int main (int argc,char **argv) {


	
	// Fensterinitialisierung
	glutInit (&argc,argv);
	glutInitWindowSize (WIN_WIDTH,WIN_HEIGHT);
	glutInitWindowPosition (WIN_POS_X,WIN_POS_Y);
	glutInitDisplayMode (USED_MODUS);
	MainWin = glutCreateWindow (PROG_NAME);

	// OpenGL Initialisierungen
	glEnable (GL_DEPTH_TEST);
	
	// Menu erzeugen
	MainMenu = glutCreateMenu (MenuFuncFile);
	glutAddMenuEntry (MENU_OPEN,ID_MENU_OPEN);
	glutAddMenuEntry (MENU_SHADE,ID_MENU_SHADE);
	glutAddMenuEntry (MENU_EXIT,ID_MENU_EXIT);
	glutAttachMenu (GLUT_RIGHT_BUTTON);		// Menu ist mapped auf 
											// rechte Maustaste
	// Callback funktion
	glutDisplayFunc (DisplayFunc);
	glutReshapeFunc (ReshapeFunc);
	glutMouseFunc (MouseFunc);
	glutMotionFunc (MouseMove);
	glutKeyboardFunc (KeyboardFunc);
	glutSpecialFunc (SpecialKeyboardFunc);
	glutIdleFunc (IdleFunc);

	// Initiale Mauseigenschaften
	globMouse.LastState = -1;
	globMouse.MoveX 	= 0;
	globMouse.MoveY 	= 0;
	globMouse.Radius 	= 5;


	//schreiben lassen Anfang
	//Texturnamen erzeugen
	glGenTextures(9,mapnames);

	//Maps einlesen und spez. mit specTexture
    specTexture("cube_face_negx.ppm", mapnames[0]);
    specTexture("cube_face_posx.ppm", mapnames[1]);
    specTexture("cube_face_negy.ppm", mapnames[2]);
    specTexture("cube_face_posy.ppm", mapnames[3]);
    specTexture("cube_face_negz.ppm", mapnames[4]);
    specTexture("cube_face_posz.ppm", mapnames[5]);
		specTexture("berge.ppm",mapnames[6]);
		specTexture("checker.ppm",mapnames[7]);
		specTexture("holz.ppm",mapnames[8]);
	//schreiben lassen ende

	// Die Hauptschleife
	glutMainLoop ();
	return 0;
}

//
//	Menu CALLBACK Funktion
//
void MenuFuncFile (int Item) {
	int i;
	switch (Item) {
		case ID_MENU_EXIT:
			for (i=0;i<8;i++)
				glDeleteTextures(8,mapnames);
			exit (0);
			break;
		case ID_MENU_SHADE:
			break;
		case ID_MENU_OPEN:
			break;
		}
}



//ein ppm-File lesen
GLubyte* read_Texture(char* pfad,int width, int height)
{
	GLubyte* newimage;// [300] [300] [3];
	GLubyte* scalednewimage;// [256] [256] [3];

	int breite,hoehe,i,j,color=0;
	char text[100];
	
	FILE		*filestream=NULL;

	filestream = fopen(pfad, "rb" );
	for (i=0;i<7;i++)
	{
		fscanf(filestream, "%s",&text);
	};
	fscanf( filestream, "%d", &color );
	fscanf( filestream, "%d", &breite );
	fscanf( filestream, "%d", &hoehe );
	fscanf( filestream, "%d", &color );
	newimage=(GLubyte*) malloc(3*breite*hoehe*sizeof(GLubyte));
	scalednewimage=(GLubyte*) malloc(3*width*height*sizeof(GLubyte));
	for (i=0;i<hoehe;i++)
	{
		for (j=0;j<breite;j++)
		{
			fscanf( filestream, "%d", &color );
			newimage[(i*3*breite)+(j*3)] = (GLubyte) color;
			fscanf( filestream, "%d", &color );
			newimage[(3*breite*i)+(j*3)+1] = (GLubyte) color;
			fscanf( filestream, "%d", &color );
			newimage[(3*breite*i)+(j*3)+2] = (GLubyte) color;
		
		};
	};
	fclose(filestream);
	gluScaleImage(GL_RGB,hoehe,breite,GL_UNSIGNED_BYTE,newimage,
					width,height,GL_UNSIGNED_BYTE,scalednewimage);

	free(newimage);
	return(scalednewimage);
};

void specTexture(char *pfad, GLuint mapname)
{
	//schreiben lassen_ Anfang
	
	//Texturimage
	GLubyte* texture; 
	
	texture=read_Texture(pfad,twidth,theight);
	glBindTexture(GL_TEXTURE_2D,mapname);
	glTexImage2D(
      GL_TEXTURE_2D,
      0,                  // level
      GL_RGB,          		// internal format
      twidth,     				// width
      theight,     			  // height
      0,                  // border
      GL_RGB,          	  // format
      GL_UNSIGNED_BYTE,		// type
      texture); // pixel data

	//Texturfilterung konfigurieren
	glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_NEAREST);
	glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_LINEAR);
	
	//Behandlung von Texturkoordinaten
	glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_WRAP_S, GL_CLAMP_TO_EDGE);
	glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_WRAP_T, GL_CLAMP_TO_EDGE);
	free(texture);
	//schreiben lassen_ Ende

}

//
//	Display CALLBACK Funktion - wird immer aufgerufen, wenn der 
//	Inhalt des Viewports aktualisiert werden muss (z.B. nach
//	Aufruf der Funktion 'glutPostRedisplay ()').
//
void DisplayFunc () {

	
	// Buffer neu initialisieren
	glClear (GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);

	// Ansichtstransformationen
	glMatrixMode (GL_MODELVIEW);
	glLoadIdentity ();
	double x,y,z, The,Phi;
	Phi = (double)globMouse.MoveX / (double)globMouse.ScreenX * M_PI * 2.0;
	The = (double)globMouse.MoveY / (double)globMouse.ScreenY * M_PI * 2.0;
	x = globMouse.Radius * cos (Phi) * cos (The);
	y = globMouse.Radius * sin (The);
	z = globMouse.Radius * sin (Phi) * cos (The);
	int Oben = (The <= 0.5 * M_PI || The > 1.5 * M_PI) * 2 - 1;
	gluLookAt (x,y,z, 0,0,0, 0, Oben, 0);


	
	//schreiben lassen
	//Umgebung rendern
	glActiveTexture(GL_TEXTURE0);
	glEnable(GL_TEXTURE_2D);
	glTexEnvf(GL_TEXTURE_ENV, GL_TEXTURE_ENV_MODE, GL_REPLACE);

    draw_environment_cube();
	glDisable(GL_TEXTURE_2D);

	//Teapot rendern
	glActiveTexture(GL_TEXTURE0);
	glEnable(GL_TEXTURE_2D);
    glBindTexture(GL_TEXTURE_2D,mapnames[7]);
	glTexEnvf(GL_TEXTURE_ENV, GL_TEXTURE_ENV_MODE, GL_REPLACE);


	glActiveTexture(GL_TEXTURE1);
    glBindTexture(GL_TEXTURE_2D,mapnames[6]);
	glEnable(GL_TEXTURE_2D);

	glTexEnvf(GL_TEXTURE_ENV, GL_TEXTURE_ENV_MODE, GL_MODULATE);
    glTexGeni(GL_S, GL_TEXTURE_GEN_MODE, GL_SPHERE_MAP);
    glTexGeni(GL_T, GL_TEXTURE_GEN_MODE, GL_SPHERE_MAP);

    glEnable(GL_TEXTURE_GEN_S);
    glEnable(GL_TEXTURE_GEN_T);

	glutSolidTeapot(1);


    glDisable(GL_TEXTURE_GEN_S);
    glDisable(GL_TEXTURE_GEN_T);
    glDisable(GL_TEXTURE_GEN_R);
	glDisable(GL_TEXTURE_2D);


	//Quad rendern
	glActiveTexture(GL_TEXTURE0);
	glEnable(GL_TEXTURE_2D);
    glBindTexture(GL_TEXTURE_2D,mapnames[8]);
	glTexEnvf(GL_TEXTURE_ENV, GL_TEXTURE_ENV_MODE, GL_REPLACE);

	glActiveTexture(GL_TEXTURE1);
	glEnable(GL_TEXTURE_2D);
    glBindTexture(GL_TEXTURE_2D,mapnames[7]);
	glTexEnvf(GL_TEXTURE_ENV, GL_TEXTURE_ENV_MODE, GL_MODULATE);

	draw_ground();

	glDisable(GL_TEXTURE_2D);

	//schreiben lassen
	
	glFlush ();				// Daten an Server (fuer die Darstellung) 
							// schicken
	glutSwapBuffers();		// Buffers wechseln
}

//
//	Resize CALLBACK Funktion - wird aufgerufen, wenn sich die 
//	Fenstergroesse aendert
//		w,h: neue Breite und Hoehe des Fensters
//
void ReshapeFunc (int w, int h) {
	glMatrixMode (GL_PROJECTION);
	glLoadIdentity ();
	gluPerspective (45, (double)w/(double)h, 1, 2000);
	glViewport (0, 0, w, h);
	glMatrixMode (GL_MODELVIEW);	// Sicherheit halber 
	glLoadIdentity ();				// Modelierungsmatrix einstellen
	globMouse.ScreenX = w;			
	globMouse.ScreenY = h;
}

//
//	Maus Button CALLBACK Funktion
//		button - Welche Taste betaetigt bzw. losgelassen wurde
//		state  - Status der State (GL_DOWN, GL_UP)
//		x, y   - Fensterkoordinaten des Mauszeigers
//
void MouseFunc (int button, int state, int x, int y) {
	globMouse.LastState = (state == GLUT_DOWN) ? button : -1;
	switch (button) {
		// Linke Taste - mit Rotation verknuepft
		case GLUT_LEFT_BUTTON:
			if (state == GLUT_DOWN) {
				globMouse.OldX = x;
				globMouse.OldY = y;
				}
			break;
		// Mittlere Taste - mit Skalierung verknuepft
		case GLUT_MIDDLE_BUTTON:
			if (state == GLUT_DOWN)
				globMouse.OldY = y;
			break;
		// Rechte Taste - reserviert fuer Menue
		case GLUT_RIGHT_BUTTON:
			break;
		}
}

//
//	Maus Movement CALLBACK Funktion, wenn das Mausbutton gedrueckt
//		wurde. Fuer reine Mausbewegung muss man GlutPassiveMotionFunc
//		einstellen.
//
void MouseMove (int x, int y) {
	switch (globMouse.LastState) {
		case GLUT_LEFT_BUTTON:
			globMouse.MoveX += x - globMouse.OldX;
			globMouse.MoveY += y - globMouse.OldY;
			if (globMouse.MoveX > globMouse.ScreenX)
				globMouse.MoveX -= globMouse.ScreenX;
			if (globMouse.MoveX < 0)
				globMouse.MoveX =+ globMouse.ScreenX;
			if (globMouse.MoveY > globMouse.ScreenY)
				globMouse.MoveY -= globMouse.ScreenY;
			if (globMouse.MoveY < 0)
				globMouse.MoveY =+ globMouse.ScreenY;
			globMouse.OldX = x;
			globMouse.OldY = y;
			glutPostRedisplay ();
			break;
		case GLUT_MIDDLE_BUTTON:
			globMouse.Radius += y - globMouse.OldY;
			globMouse.Radius = MAX (globMouse.Radius,1);
			globMouse.Radius = MIN (globMouse.Radius,8);
			globMouse.OldX = x;
			globMouse.OldY = y;
			glutPostRedisplay ();
			break;
		case GLUT_RIGHT_BUTTON:
			break;
		}			
}

//
//	Tastatur CALLBACK Funktion
//		key: Wert der Taste die gedrueckt wurde
//		x,y: Position des Mauskursors auf dem Viewport
//
void KeyboardFunc (unsigned char key, int x, int y) {
	int i;
	switch (key) {
		// Escape
		case 27:
			for (i=0;i<8;i++)
				glDeleteTextures(8,mapnames);
			exit (0);
		// Initialisierung
		case 'i':
		case 'I':
			globMouse.MoveX = 0;
			globMouse.MoveY = 0;
			glutPostRedisplay ();
			break;
		}
}

//
//	CALLBACK Funktion fuer spezielle Tasten (Kursortasten, F-Tasten usw.)
//		key - Code der Taste (siehe glut Spezifikation)
//
void SpecialKeyboardFunc (int key, int x, int y) {
	switch (key) {
		case GLUT_KEY_UP:
			break;
		case GLUT_KEY_DOWN:
			break;
		case GLUT_KEY_LEFT:
			break;
		case GLUT_KEY_RIGHT:
			break;
		case GLUT_KEY_F1:
			break;
		}
	glutPostRedisplay ();
}


//
//	CALLBACK Funktion fuer Idle: wird aufgerufen, wenn die CPU nichts
//	anderes zu tun hat: oft fuer Animation verwendet 
//
void IdleFunc () {
}


///////////////////////////////////////////////////////////////////////
//
//	Modellierungsfunktionen
//
///////////////////////////////////////////////////////////////////////

void draw_environment_cube()
{
	glPushMatrix();
	glRotatef(270.0,0.0,1.0,0.0);
	glScalef(15.0,15.,15.);
	glBindTexture(GL_TEXTURE_2D,mapnames[0]);
	glBegin(GL_QUADS);
		glColor4f(0.9f,0.0f,0.0f,1.0f);
		glTexCoord2f(1.0f,1.0f);glNormal3f(-1.0,0.0,0.0);glVertex3f(-0.5, -0.5, -0.5);
		glTexCoord2f(0.0f,1.0f);glNormal3f(-1.0,0.0,0.0);glVertex3f(-0.5, -0.5,  0.5);
		glTexCoord2f(0.0f,0.0f);glNormal3f(-1.0,0.0,0.0);glVertex3f(-0.5,  0.5,  0.5);
		glTexCoord2f(1.0f,0.0f);glNormal3f(-1.0,0.0,0.0);glVertex3f(-0.5,  0.5, -0.5);
    glEnd();
	glBindTexture(GL_TEXTURE_2D,mapnames[5]);
	glBegin(GL_QUADS);
		glColor4f(0.0f,0.9f,0.0f,1.0f);
		glTexCoord2f(0.0f,1.0f);glNormal3f(0.0,0.0,-1.0);glVertex3f(-0.5, -0.5,-0.5);
		glTexCoord2f(0.0f,0.0f);glNormal3f(0.0,0.0,-1.0);glVertex3f(-0.5,  0.5,-0.5);
		glTexCoord2f(1.0f,0.0f);glNormal3f(0.0,0.0,-1.0);glVertex3f( 0.5,  0.5,-0.5);
		glTexCoord2f(1.0f,1.0f);glNormal3f(0.0,0.0,-1.0);glVertex3f( 0.5, -0.5,-0.5);
    glEnd();
	glBindTexture(GL_TEXTURE_2D,mapnames[3]);
	glBegin(GL_QUADS);
		glColor4f(0.0f,0.0f,0.9f,1.0f);
		glTexCoord2f(0.0f,0.0f);glNormal3f(0.0,-1.0,0.0);glVertex3f(-0.5,-0.5,-0.5);
		glTexCoord2f(0.0f,1.0f);glNormal3f(0.0,-1.0,0.0);glVertex3f(-0.5,-0.5, 0.5);
		glTexCoord2f(1.0f,1.0f);glNormal3f(0.0,-1.0,0.0);glVertex3f( 0.5,-0.5, 0.5);
		glTexCoord2f(1.0f,0.0f);glNormal3f(0.0,-1.0,0.0);glVertex3f( 0.5,-0.5,-0.5);
    glEnd();
	glBindTexture(GL_TEXTURE_2D,mapnames[2]);
	glBegin(GL_QUADS);
		glColor4f(0.0f,0.9f,0.9f,1.0f);
		glTexCoord2f(0.0f,1.0f);glNormal3f(0.0,1.0,0.0);glVertex3f(-0.5, 0.5,-0.5);
		glTexCoord2f(0.0f,0.0f);glNormal3f(0.0,1.0,0.0);glVertex3f(-0.5, 0.5, 0.5);
		glTexCoord2f(1.0f,0.0f);glNormal3f(0.0,1.0,0.0);glVertex3f( 0.5, 0.5, 0.5);
		glTexCoord2f(1.0f,1.0f);glNormal3f(0.0,1.0,0.0);glVertex3f( 0.5, 0.5,-0.5);
    glEnd();
	glBindTexture(GL_TEXTURE_2D,mapnames[4]);
	glBegin(GL_QUADS);
		glColor4f(0.9f,0.0f,0.9f,1.0f);
		glTexCoord2f(1.0f,1.0f);glNormal3f(0.0,0.0,1.0);glVertex3f(-0.5, -0.5, 0.5);
		glTexCoord2f(1.0f,0.0f);glNormal3f(0.0,0.0,1.0);glVertex3f(-0.5,  0.5, 0.5);
		glTexCoord2f(0.0f,0.0f);glNormal3f(0.0,0.0,1.0);glVertex3f( 0.5,  0.5, 0.5);
		glTexCoord2f(0.0f,1.0f);glNormal3f(0.0,0.0,1.0);glVertex3f( 0.5, -0.5, 0.5);
    glEnd();
	glBindTexture(GL_TEXTURE_2D,mapnames[1]);
	glBegin(GL_QUADS);
		glColor4f(0.9f,0.9f,0.0f,1.0f);
		glTexCoord2f(0.0f,1.0f);glNormal3f(1.0,0.0,0.0);glVertex3f(0.5, -0.5, -0.5);
		glTexCoord2f(1.0f,1.0f);glNormal3f(1.0,0.0,0.0);glVertex3f(0.5, -0.5,  0.5);
		glTexCoord2f(1.0f,0.0f);glNormal3f(1.0,0.0,0.0);glVertex3f(0.5,  0.5,  0.5);
		glTexCoord2f(0.0f,0.0f);glNormal3f(1.0,0.0,0.0);glVertex3f(0.5,  0.5, -0.5);
    glEnd();
	glPopMatrix();

};

//schreiben lassen
void draw_ground()
{
	glPushMatrix();
	glTranslatef(0.0,-0.25,0.0);
	glScalef(4.0,1.0,4.0);
	glBegin(GL_QUADS);
		glColor4f(0.0f,0.0f,0.9f,1.0f);
		glMultiTexCoord2f(GL_TEXTURE0,1.0f,1.0f);glMultiTexCoord2f(GL_TEXTURE1,0.0f,0.0f);glNormal3f(0.0,-1.0,0.0);glVertex3f(-0.5,-0.5,-0.5);
		glMultiTexCoord2f(GL_TEXTURE0,1.0f,0.0f);glMultiTexCoord2f(GL_TEXTURE1,0.0f,1.0f);glNormal3f(0.0,-1.0,0.0);glVertex3f(-0.5,-0.5, 0.5);
		glMultiTexCoord2f(GL_TEXTURE0,0.0f,0.0f);glMultiTexCoord2f(GL_TEXTURE1,1.0f,1.0f);glNormal3f(0.0,-1.0,0.0);glVertex3f( 0.5,-0.5, 0.5);
		glMultiTexCoord2f(GL_TEXTURE0,0.0f,1.0f);glMultiTexCoord2f(GL_TEXTURE1,1.0f,0.0f);glNormal3f(0.0,-1.0,0.0);glVertex3f( 0.5,-0.5,-0.5);
    glEnd();
	glPopMatrix();

};
